#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cmath>
#include <numeric>
#include <random>
#include <chrono>
#include <ctime>

using namespace std;

#define forn(i,n) for(int i=0; i<n; ++i)

void solve() {
    int n,m;
    cin >> n >> m;
    int cnt = 0;
    for(int i = 0; i < m;++i){
        int u,v;
        cin >> u >> v;
        if(u<v) cnt++;
    }
    if(cnt >= (m+1)/2){
        for(int i = 1; i <= n; ++i){
            cout << i << ' ';
        }
        cout << '\n';
        return;
    }
    else{
        for(int i = n; i > 0; --i){
            cout << i << ' ';
        }
        cout << '\n';
        return;
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.setf(ios::fixed);
    cout.precision(20);
    int t; cin>>t;
    while (t--) solve();
}
